import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { OaAssetsVhost, OaAssetsVhostParam } from './model';

/**
 * 分页查询虚拟主机记录表
 */
export async function pageOaAssetsVhost(params: OaAssetsVhostParam) {
  const res = await request.get<ApiResult<PageResult<OaAssetsVhost>>>(
    '/oa/oa-assets-vhost/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询虚拟主机记录表列表
 */
export async function listOaAssetsVhost(params?: OaAssetsVhostParam) {
  const res = await request.get<ApiResult<OaAssetsVhost[]>>(
    '/oa/oa-assets-vhost',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加虚拟主机记录表
 */
export async function addOaAssetsVhost(data: OaAssetsVhost) {
  const res = await request.post<ApiResult<unknown>>(
    '/oa/oa-assets-vhost',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改虚拟主机记录表
 */
export async function updateOaAssetsVhost(data: OaAssetsVhost) {
  const res = await request.put<ApiResult<unknown>>(
    '/oa/oa-assets-vhost',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除虚拟主机记录表
 */
export async function removeOaAssetsVhost(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    '/oa/oa-assets-vhost/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除虚拟主机记录表
 */
export async function removeBatchOaAssetsVhost(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    '/oa/oa-assets-vhost/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询虚拟主机记录表
 */
export async function getOaAssetsVhost(id: number) {
  const res = await request.get<ApiResult<OaAssetsVhost>>(
    '/oa/oa-assets-vhost/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
